e_atan2.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for e_atan2.c:

Go to the source code of this file.

## Functions

double attribute_hidden | __ieee754_atan2 (double y, double x)

## Variables

static const double | tiny = 1.0e-300
static const double | zero = 0.0
static const double | pi_o_4 = 7.8539816339744827900E-01
static const double | pi_o_2 = 1.5707963267948965580E+00
static const double | pi = 3.1415926535897931160E+00
static const double | pi_lo = 1.2246467991473531772E-16

## Function Documentation

double attribute_hidden __ieee754_atan2 | ( | double | y,
|  | double | x
| ) |  |

Definition at line 50 of file e_atan2.c.

References atan(), EXTRACT_WORDS, fabs, GET_HIGH_WORD, pi, pi_lo, pi_o_2, pi_o_4, SET_HIGH_WORD, tiny, and zero.

{
double z;
int32_t k,m,hx,hy,ix,iy;
u_int32_t lx,ly;
EXTRACT_WORDS(hx,lx,x);
ix = hx&0x7fffffff;
EXTRACT_WORDS(hy,ly,y);
iy = hy&0x7fffffff;
if(((ix|((lx|-(int32_t)lx)>>31))>0x7ff00000)||
((iy|((ly|-(int32_t)ly)>>31))>0x7ff00000)) /* x or y is NaN */
return x+y;
if(((hx-0x3ff00000)|lx)==0) return atan(y); /* x=1.0 */
m = ((hy>>31)&1)|((hx>>30)&2); /* 2*sign(x)+sign(y) */
/* when y = 0 */
if((iy|ly)==0) {
switch(m) {
case 0:
case 1: return y; /* atan(+-0,+anything)=+-0 */
case 2: return pi+tiny;/* atan(+0,-anything) = pi */
case 3: return -pi-tiny;/* atan(-0,-anything) =-pi */
}
}
/* when x = 0 */
if((ix|lx)==0) return (hy<0)? -pi_o_2-tiny: pi_o_2+tiny;
/* when x is INF */
if(ix==0x7ff00000) {
if(iy==0x7ff00000) {
switch(m) {
case 0: return pi_o_4+tiny;/* atan(+INF,+INF) */
case 1: return -pi_o_4-tiny;/* atan(-INF,+INF) */
case 2: return 3.0*pi_o_4+tiny;/* atan(+INF,-INF) */
case 3: return -3.0*pi_o_4-tiny;/* atan(-INF,-INF) */
}
} else {
switch(m) {
case 0: return zero ; /* atan(+...,+INF) */
case 1: return -zero ; /* atan(-...,+INF) */
case 2: return pi+tiny ; /* atan(+...,-INF) */
case 3: return -pi-tiny ; /* atan(-...,-INF) */
}
}
}
/* when y is INF */
if(iy==0x7ff00000) return (hy<0)? -pi_o_2-tiny: pi_o_2+tiny;
/* compute y/x */
k = (iy-ix)>>20;
if(k > 60) z=pi_o_2+0.5*pi_lo; /* |y/x| > 2**60 */
else if(hx<0&&k<-60) z=0.0; /* |y|/x < -2**60 */
else z=atan(fabs(y/x)); /* safe to do y/x */
switch (m) {
case 0: return z ; /* atan(+,+) */
case 1: {
u_int32_t zh;
GET_HIGH_WORD(zh,z);
SET_HIGH_WORD(z,zh ^ 0x80000000);
}
return z ; /* atan(-,+) */
case 2: return pi-(z-pi_lo);/* atan(+,-) */
default: /* case 3 */
return (z-pi_lo)-pi;/* atan(-,-) */
}
}
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:103
pi
static const double pi
Definition: e_atan2.c:47
tiny
static const double tiny
Definition: e_atan2.c:43
int32_t
signed int int32_t
Definition: SDL_config_windows.h:61
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
m
const GLfloat * m
Definition: SDL_opengl_glext.h:6092
pi_o_4
static const double pi_o_4
Definition: e_atan2.c:45
SET_HIGH_WORD
#define SET_HIGH_WORD(d, v)
Definition: math_private.h:131
pi_lo
static const double pi_lo
Definition: e_atan2.c:48
zero
static const double zero
Definition: e_atan2.c:44
u_int32_t
unsigned int u_int32_t
Definition: math_private.h:29
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
EXTRACT_WORDS
#define EXTRACT_WORDS(ix0, ix1, d)
Definition: math_private.h:93
pi_o_2
static const double pi_o_2
Definition: e_atan2.c:46
fabs
#define fabs
Definition: math_private.h:36
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
atan
double atan(double x)
Definition: s_atan.c:67

## Variable Documentation

const double pi = 3.1415926535897931160E+00

static

Definition at line 47 of file e_atan2.c.

Referenced by __ieee754_atan2().

const double pi_lo = 1.2246467991473531772E-16

static

Definition at line 48 of file e_atan2.c.

Referenced by __ieee754_atan2().

const double pi_o_2 = 1.5707963267948965580E+00

static

Definition at line 46 of file e_atan2.c.

Referenced by __ieee754_atan2().

const double pi_o_4 = 7.8539816339744827900E-01

static

Definition at line 45 of file e_atan2.c.

Referenced by __ieee754_atan2().

const double tiny = 1.0e-300

static

Definition at line 43 of file e_atan2.c.

Referenced by __ieee754_atan2().

const double zero = 0.0

static

Definition at line 44 of file e_atan2.c.

Referenced by __ieee754_atan2().